﻿package
{

	import flash.events.Event;
	import flash.events.MouseEvent;
	import org.papervision3d.core.math.Matrix3D;
	import org.papervision3d.core.math.Number3D;
	import org.papervision3d.core.math.Quaternion;
	import org.papervision3d.objects.primitives.Cube;
	import org.papervision3d.objects.primitives.Sphere;
	import org.papervision3d.scenes.Scene3D;
	
	public class CubeUnit 
	{
		static internal const CENTER:int = 1;
		static internal const EDGE:int = 2;
		static internal const CORNER:int= 3;

		static internal const RATE:int = 64;

		private var tg:Sphere;
		
		private var base:Cube;	
		private var sheel:Array;

		private var status:int;		
		
		static internal var count:uint = 0;
		static private var axis:int;

		static private var rotate_group:Array;
				
		
		public function CubeUnit(scene:Sphere, status:int, base:Cube, sheel:Array)
		{

			this.tg = new Sphere(null, Number.MIN_VALUE);

			this.base = base;
			this.sheel = sheel;
			this.status = status;

			this.tg.addChild(this.base);

			for each(var v:Sheel in this.sheel) {
				this.tg.addChild(v);
				
			}

			scene.addChild(this.tg);
			
		}		
		
		private function color_change(axis:int):void {

			for each(var v:Sheel in this.sheel) {
				if (v.color_group != axis) {
					v.set_color_group(axis);
				}				
			}
		}		

		static internal function rotate_color(i:int, j:int, k:int, axis:int, rotate_group:Array, rg:int):int {

			if(i != 1 || j != 1 || k != 1)
				for (var sheels:int = 0; sheels < RubicCube.cube[i][j][k].status; sheels++) {
										
					if(RubicCube.cube[i][j][k].sheel[sheels].color_group == axis) {
						rotate_group[rg] = RubicCube.cube[i][j][k];
						RubicCube.cube[i][j][k].color_change(axis);
						return 1;
					}
				}	
			return 0;
		}
		


		
		static internal function rotate(axis:int):void {
			
			rotate_group = new Array(9);

			var rg:int = 0;
			for(var i:int = 0; i < 3; i++)
				for(var j:int = 0; j < 3; j++)
					for(var k:int = 0; k < 3; k++)
						rg += rotate_color(i, j, k, axis, rotate_group, rg);

						
			count = 30;
			CubeUnit.axis = axis;
			Main.container.addEventListener(Event.ENTER_FRAME, onRotation);
						
		}
		
		
		static private function onRotation(event:Event):void {

			for each(var v:CubeUnit in rotate_group) {
				v.quaternionXYZ();
			}
						
			if ((--count) == 0) {
				Main.container.removeEventListener(Event.ENTER_FRAME, onRotation);
			}
		}
		
		
		private function quaternionXYZ():void {
			
			var pos1:Quaternion = Quaternion.createFromMatrix(tg.transform);
			var pos2:Quaternion = Quaternion.createFromEuler(Sheel.angle[axis][1], Sheel.angle[axis][2], Sheel.angle[axis][0], true);

			pos2.normalize();
			pos2.mult(pos1);
			pos2.normalize();
						
			tg.copyTransform(Matrix3D.quaternion2matrix(pos2.x, pos2.y, pos2.z, pos2.w));
			
		}
		
		
	}	
}

